package net.sourceforge.asse;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.event.TableModelEvent;
import java.util.*;

class DeletedDialog  extends JDialog implements ActionListener {

    public DeletedDialog (JFrame frame, String title, myJDBCAdapter jp) {
	
	super (frame, title, true);
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	getContentPane().setLayout( new BorderLayout());

	jadapter = jp;
	jt = new JTable(jadapter.get_deleted());
	jt.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
	{
	    JScrollPane j = new JScrollPane(jt);
	    j.setPreferredSize(new Dimension(100,100));
// 	    j.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
// 	    j.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
	    this.getContentPane().add(j, BorderLayout.CENTER);
	}

	jt.getSelectionModel().addListSelectionListener(new ListSelectionListener() 
	    {
		public void valueChanged(ListSelectionEvent e) {
		    
		    int row = jt.getSelectedRow();
		    if (e.getValueIsAdjusting())
			    return;

		    if (row < 0) 
			button_panel.setEnabled("UnDelete", false);
		    else
			button_panel.setEnabled("UnDelete", true);

		    return;
		}
	    } );
	
	
	String buttons[] = new String[2];
	buttons[0] = "UnDelete";
	buttons[1] = "OK";
	button_panel = new JButtonPanel (buttons);
	button_panel.setEnabled("UnDelete", false);
	button_panel.addActionListener(this);	
	setSize(	DwbjProps.getIntProperty("DeletedDialogwidth", 200),
		DwbjProps.getIntProperty("DeletedDialogheight", 200));
    
	this.getContentPane().add(button_panel, BorderLayout.SOUTH);
	setLocationRelativeTo(frame);
	this.show();
    }

    protected void processWindowEvent(WindowEvent e) {

        if (e.getID() == WindowEvent.WINDOW_CLOSING)   {
	    try {
		DwbjProps.setIntProperty("DeletedDialogwidth", getWidth());
		DwbjProps.setIntProperty("DeletedDialogheight", getHeight());
	    }
	    catch (Exception ex) {
	    }
	}
    
        super.processWindowEvent(e);
    }

    public void actionPerformed (ActionEvent ae) {

	String whatsup;

	whatsup = ae.getActionCommand();
	if (whatsup.compareTo("OK") == 0) {
	    WindowEvent we = new WindowEvent(this, WindowEvent.WINDOW_CLOSING);
	    this.dispatchEvent(we);
	} else if (whatsup.compareTo("UnDelete") == 0) {
	    int rowlist[] = jt.getSelectedRows();
	    DefaultTableModel dtable;
	    dtable = (DefaultTableModel)jt.getModel();

	    Vector  dataVector = dtable.getDataVector();
	    for (int i = 0; i < rowlist.length ; i++) {
		System.out.println("Removing row" + rowlist[i]);
		Vector rowVector = (Vector) dataVector.elementAt( rowlist[i]);
		jadapter.reAddRow( rowVector );
	    }
	    for (int i = rowlist.length  - 1; i >= 0 ; i--) {
		dtable.removeRow(rowlist[i]);
		System.out.println("Removing row" + rowlist[i]);
	    }
	    jt.tableChanged(new TableModelEvent(dtable));
	    button_panel.setEnabled("UnDelete", false);
	}
    }
	
    JTable           jt;
    JButtonPanel     button_panel;
    static int       sheight =0;
    static int       swidth =0;
    myJDBCAdapter    jadapter;

    
}
