
package net.sourceforge.asse;

// The following is lifted code -Manish
//
//
//  About the author
//  Ashok Banerjee and Jignesh Mehta are both currently working 
//  with Oracle Corporation on manufacturing applications. 
//  They have been using Java for around two years. 
//
//  Published in Java World
//  http://www.javaworld.com/javaworld/javatips/jw-javatip77.html

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.datatransfer.*;
import java.util.*;
import javax.swing.table.*;
import javax.accessibility.*;

/**
 * ExcelAdapter enables Copy-Paste Clipboard functionality on JTables.
 * The clipboard data format used by the adapter is compatible with
 * the clipboard format used by Excel. This provides for clipboard
 * interoperability between enabled JTables and Excel.
*/
public class ExcelAdapter 
{
    /**
     * The Excel Adapter is constructed with a
     * JTable on which it enables Copy-Paste and acts
     * as a Clipboard listener.
     */

    static String keys_buffer = "";
    
    public static String get_keys() {
          return keys_buffer;
    }
    
    public static void copy_to_excel(JTable jTable1)
    {

	String rowstring,value;
	Clipboard system;
	StringSelection stsel;

	StringBuffer sbf=new StringBuffer();
	// Check to ensure we have selected only a contiguous block of
	// cells
	int numcols=jTable1.getColumnCount();
	int numrows=jTable1.getRowCount();

	// Add column name in the selection.
	// This is useful to most people.
	for (int j=0;j<numcols;j++)
	    {
		sbf.append(jTable1.getColumnName(j));
		if (j<numcols-1) sbf.append("\t");
	    }
	sbf.append("\n");
	
	for (int i=0;i<numrows;i++)
	    {
		for (int j=0;j<numcols;j++)
		    {
                        TableCellRenderer tcr = jTable1.getCellRenderer(i, j);
                        java.awt.Component comp = tcr.getTableCellRendererComponent(jTable1, jTable1.getValueAt(i, j), false, false, i, j);
                        Object o1 = null;
                        try {
                            Class[] paramtype;
                            java.lang.reflect.Method getText = comp.getClass().getMethod("getText", null);
                            o1 = getText.invoke(comp, null);
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }
                        if (o1 == null)
                            o1 = "";
			sbf.append( o1.toString());
			if (j<numcols-1) sbf.append("\t");
		    }
		sbf.append("\n");
	    }
	stsel  = new StringSelection(sbf.toString());
	system = Toolkit.getDefaultToolkit().getSystemClipboard();
	system.setContents(stsel,stsel);

	//System.out.println("CopyTableBuffer:\n" + sbf.toString());

	return;
    }

        
//    public static void copy_to_excel(myJDBCAdapter mytable)
//    {
//
//	String rowstring,value;
//	Clipboard system;
//	StringSelection stsel;
//
//	StringBuffer sbf=new StringBuffer();
//	// Check to ensure we have selected only a contiguous block of
//	// cells
//	int numcols=mytable.getColumnCount();
//	int numrows=mytable.getRowCount();
//
//	// Add column name in the selection.
//	// This is useful to most people.
//	for (int j=0;j<numcols;j++)
//	    {
//		sbf.append(mytable.getColumnName(j));
//		if (j<numcols-1) sbf.append("\t");
//	    }
//	sbf.append("\n");
//	
//	for (int i=0;i<numrows;i++)
//	    {
//		for (int j=0;j<numcols;j++)
//		    {
//			sbf.append(mytable.getValueAt(i, j));
//			if (j<numcols-1) sbf.append("\t");
//		    }
//		sbf.append("\n");
//	    }
//	stsel  = new StringSelection(sbf.toString());
//	system = Toolkit.getDefaultToolkit().getSystemClipboard();
//	system.setContents(stsel,stsel);
//
//	//System.out.println("CopyTableBuffer:\n" + sbf.toString());
//
//	return;
//    }
//    
    //copies specified row  to the clipboard with columns
    
    public static void copy_keys(int selected_row, myJDBCAdapter mytable)
    {

	String rowstring,value;
	Clipboard system;
	StringSelection stsel;

	StringBuffer sbf=new StringBuffer();
	// Check to ensure we have selected only a contiguous block of
	// cells
	int numcols=mytable.getColumnCount();
	int numrows=mytable.getRowCount();

	// Add column name in the selection.
	// This is useful to most people.
	for (int j=0;j<numcols;j++)
	    {
		sbf.append(mytable.getColumnName(j));
		if (j<numcols-1) sbf.append("\t");
	    }
	sbf.append("\n");
	
	int i = selected_row;
	    {
		for (int j=0;j<numcols;j++)
		    {
			sbf.append(mytable.getValueAt(i, j));
			if (j<numcols-1) sbf.append("\t");
		    }
		sbf.append("\n");
	    }
        
        keys_buffer = sbf.toString();
        
//	stsel  = new StringSelection(sbf.toString());
//	system = Toolkit.getDefaultToolkit().getSystemClipboard();
//	system.setContents(stsel,stsel);
//
//	//System.out.println("CopyTableBuffer:\n" + sbf.toString());
//
//	return;
    }
}

