package net.sourceforge.asse;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


class FrameMenu extends JMenuBarEx {
	
    public FrameMenu (JDesktopPane dtp, assemdi_frame frame) {

	desktopPane = dtp;
	mdiframe    = frame;
        Boolean falseb = new Boolean(false);
             
        menudefs.put("Close Window",  falseb);
        menudefs.put("Print Table", falseb);
        menudefs.put("Save Table As...", falseb);
       // menudefs.put("Print Report", falseb);
       // menudefs.put("Save Report As...", falseb);
        menudefs.put("File Save", falseb);
        menudefs.put("File Save As...", falseb);
        menudefs.put("Insert Query From...", falseb);
        menudefs.put("Show as Plain Text", falseb);
        menudefs.put("Print SQL", falseb);
        menudefs.put("PasteKeys", falseb);
        menudefs.put("Undo", falseb);
        menudefs.put("Redo", falseb);
        menudefs.put("Find", falseb);
        menudefs.put("Stop", falseb);
        menudefs.put("Run", falseb);
        menudefs.put("Insert", falseb);
        menudefs.put("Delete", falseb);
        menudefs.put("Show Deleted", falseb);
        menudefs.put("Commit", falseb);
        menudefs.put("Duplicate Rows", falseb);
        menudefs.put("Reset", falseb);
        menudefs.put("Clear Results", falseb);
        
        JMenuItem jmi;
	JMenu jm = new JMenu("File");
	jm.setMnemonic(KeyEvent.VK_F);
	
        jm.add(jmi = new JMenuItemEx("Open SQL file",KeyEvent.VK_Q));
        jm.add(jmi = new JMenuItemEx("Open Table", KeyEvent.VK_T));
	jm.add(jmi = new JMenuItem("Open Report")); //,KeyEvent.VK_P));
        jm.add(jmi = new JMenuItemEx("Open Schema", KeyEvent.VK_M));
        jm.addSeparator();
	jm.add(jmi = new JMenuItemEx("Connect to Database",KeyEvent.VK_D));
	jm.add(jmi = new JMenuItemEx("Close Window", KeyEvent.VK_L));
	jm.add(jmi = new JMenuItemEx("Print Table", KeyEvent.VK_P, "control shift P"));
	jm.add(jmi = new JMenuItemEx("Save Table As...", KeyEvent.VK_V));
//        jm.add(jmi = new JMenuItemEx("Print Report", KeyEvent.VK_P,  "control shift P"));
//	jm.add(jmi = new JMenuItemEx("Save Report As...", KeyEvent.VK_V));
        jm.add(jmi = new JMenuItemEx("File Save", KeyEvent.VK_S, "control S"));
	jm.add(jmi = new JMenuItemEx("File Save As...", KeyEvent.VK_A));
	jm.add(jmi = new JMenuItemEx("Insert Query From...", KeyEvent.VK_I));
	jm.add(jmi = new JMenuItem("Show as Plain Text"));
	jm.add(jmi = new JMenuItemEx("Print SQL", KeyEvent.VK_P));
        jm.add(jmi = new JMenuItem("Read Servers From..."));
	jm.addSeparator();
        jm.add(jmi = new JMenuItemEx("Exit", KeyEvent.VK_X));
        jm.addSeparator();
	jm.add(jmi = new JMenuItemEx("Recent..", KeyEvent.VK_R));
        
	this.add(jm);

	jm = new JMenu("Edit");
	jm.setMnemonic(KeyEvent.VK_E);
	jm.add(jmi = new JMenuItemEx("Copy", KeyEvent.VK_C));
	jm.add(jmi = new JMenuItemEx("Cut", KeyEvent.VK_T));
	jm.add(jmi = new JMenuItemEx("Paste", KeyEvent.VK_P));
        jm.addSeparator();
	jm.add(jmi = new JMenuItemEx("CopyTable", KeyEvent.VK_O, "control shift X"));
        jm.add(jmi = new JMenuItemEx("CopyKeys", KeyEvent.VK_K, "control shift C"));
	jm.add(jmi = new JMenuItemEx("PasteKeys", KeyEvent.VK_A, "control shift V"));
        jm.addSeparator();
	jm.add(jmi_undo = new JMenuItemEx("Undo", KeyEvent.VK_U,"control Z"));
	jm.add(jmi_redo = new JMenuItemEx("Redo", KeyEvent.VK_R,"control Y"));
        jm.addSeparator();
	jmi_undo.setEnabled(false);
	jmi_redo.setEnabled(false);
	jm.add(jmi = new JMenuItemEx("Find", KeyEvent.VK_F));

        jm.add(jmi = new JMenuItemEx("Select1", KeyEvent.VK_1, KeyEvent.VK_1));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select2", KeyEvent.VK_2, KeyEvent.VK_2 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select3", KeyEvent.VK_3, KeyEvent.VK_3 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select4", KeyEvent.VK_4, KeyEvent.VK_4 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select5", KeyEvent.VK_5, KeyEvent.VK_5 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select6", KeyEvent.VK_6, KeyEvent.VK_6 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select7", KeyEvent.VK_7, KeyEvent.VK_7 ));
	jmi.setVisible(false);
	this.add(jm);

	jm = new JMenu("Query");
	jm.setMnemonic(KeyEvent.VK_Q);
	jm.add(jmi = new JMenuItemEx("Run", KeyEvent.VK_R, "control R"));
	jm.add(jmi = new JMenuItemEx("Stop", KeyEvent.VK_T));
        jm.addSeparator();
	jm.add(jmi = new JMenuItemEx("Insert", KeyEvent.VK_I, "control I"));
	jm.add(jmi = new JMenuItemEx("Delete", KeyEvent.VK_D, "control D"));
	jm.add(new JMenuItem("Show Deleted"));
	jm.add(jmi = new JMenuItemEx("Commit", KeyEvent.VK_M, "control M"));
	jm.add(jmi = new JMenuItemEx("Duplicate Rows", KeyEvent.VK_P));
	jm.add( new JMenuItem("Undo"));
	jm.add( new JMenuItemEx("Clear Results", KeyEvent.VK_L));
        
	this.add(jm);
	
	jm = new JMenu("Window"); 
        jm.setMnemonic(KeyEvent.VK_W);
        
	jm.add(jmi = new JMenuItemEx("Cascade Windows", KeyEvent.VK_C));
	jm.add(jmi = new JMenuItemEx("Tile Windows", KeyEvent.VK_T));
        jm.addSeparator();
	jm.add(jmi = new JMenuItemEx("Toggle Windows", KeyEvent.VK_T, "alt T"));
        
	jm.add(jmi = new JMenuItemEx("Cycle Windows", KeyEvent.VK_Y));
        

	window_menu = jm;

	this.add(jm);

	jm = new JMenu("Options");
	jm.setMnemonic(KeyEvent.VK_O);
	jm.add(jmi = new JMenuItem("Set Options..."));

        this.add(jm);

	jm = new JMenu("Help");
	jm.setMnemonic(KeyEvent.VK_H);
        
	jm.add(jmi = new JMenuItem("No_Help_Yet"));
	jmi.setToolTipText("Please see the manual.");
	jm.add(jmi = new JMenuItem("About", KeyEvent.VK_A));

	this.add(jm);

	wincloselistener = new InternalFrameAdapter() {
		public void internalFrameClosed(InternalFrameEvent e) {
		    refresh_windowmenu();
		}
	    }; 

	wlistener = new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    String title = ae.getActionCommand();
		    JInternalFrame jif = mdiframe.locateTitleFrame(title);
		    if (jif != null) {
			try {
			    jif.setIcon(false);
			    jif.toFront();
			    jif.setSelected(true);
			} catch (Exception ex) {
			}
		    }
		}
	    };
            
        setItems(null);
    }

    
    public void refresh_windowmenu() {
	
     	JInternalFrame [] frames = desktopPane.getAllFrames();
        if (frames.length > 0)
            window_menu.addSeparator();
        
	if (base_count == 0)
	    base_count = window_menu.getItemCount();

	for (int i = window_menu.getItemCount() - 1; i >= base_count; i--) 
	    window_menu.remove(i);
	
        for (int i = 0; i < frames.length; i++ ) {
	    frames[i].removeInternalFrameListener( wincloselistener );
	    frames[i].addInternalFrameListener( wincloselistener );
	    window_menu.add( frames[i].getTitle());
	    window_menu.getItem(base_count + i).addActionListener( wlistener );
	}
    } 

    public void setUndoRedoItems( boolean canUndo, boolean canRedo ) {
        if (canUndo)
            jmi_undo.setEnabled(true);
        else
            jmi_undo.setEnabled(false);
        
        if (canRedo)
            jmi_redo.setEnabled(true);
        else
            jmi_redo.setEnabled(false);
    }

    public void setItems(java.util.Hashtable items) {
        super.setItems(menudefs);
        if (items != null)
            super.setItems(items);
    }
    
    private JMenu        window_menu;	
    private int          base_count = 0;
    InternalFrameAdapter wincloselistener;
    JDesktopPane         desktopPane;
    assemdi_frame        mdiframe;
    ActionListener       wlistener;
    JMenuItem            jmi_redo, jmi_undo; 
    java.util.Hashtable  menudefs = new java.util.Hashtable();
}

