package net.sourceforge.asse;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;
import java.io.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JFileChooser.*;

public class JDwbjPane extends JSplitPane implements DBMultiSqlListener, DBMultiMsgListener {
    
    JTextArea jt;
    JScrollBar  jscb;
    boolean   flag_setmax = false;
    
    public void sql_to_execute(String cmd) {
	jt.append(cmd + "\ngo\n");
	flag_setmax = true;
    }

    public void msg_from_server(String str) {
//  	jt.append(str + "\n");
	jt.append(str);
	flag_setmax = true;
    }

    public JDwbjPane(JComponent topPanel) {

	super(JSplitPane.VERTICAL_SPLIT, true);
	
	this.setTopComponent(topPanel);

	jt = new JTextArea("/* SQL LOG */\n");

	{
	    JScrollPane jscr;
	    jscr = new JScrollPane(jt);
	    jscr.setPreferredSize(new Dimension(100,30));
	    jscb = jscr.getVerticalScrollBar();
	    this.setBottomComponent(jscr);
	}
	    
	jt.setEditable(false);

	jscb.addAdjustmentListener( new AdjustmentListener () {
		public void adjustmentValueChanged(AdjustmentEvent e) {
		    if (e.getID() == AdjustmentEvent.ADJUSTMENT_LAST &&
			flag_setmax) {
			jscb.setValue(jscb.getMaximum());
			flag_setmax = false;
		    }
		}
	    });

    }
	    
}






