/*
 * OptionsDialog.java
 *
 * Created on December 16, 2004, 12:12 PM
 */

package net.sourceforge.asse;
import javax.swing.*;

/**
 *
 * @author  manshah
 */
public class OptionsDialog extends javax.swing.JDialog {
    
    /** Creates new form OptionsDialog */
    public OptionsDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        DefaultComboBoxModel jcb_model;
      
        String def_datefmt = DwbjProps.getProperty("DateFormat","");
        String def_intfmt  = DwbjProps.getProperty("IntegerFormat","###");
        String def_fltfmt  = DwbjProps.getProperty("DecimalFormat","##.##");
        
        Object s_item;
        
        jcb_date.setSelectedItem(def_datefmt);
        s_item = jcb_date.getSelectedItem();
        if (s_item != null  && s_item.toString().compareTo(def_datefmt) == 0)
            ;
        else  {
            jcb_date.insertItemAt( def_datefmt, 2);
            jcb_date.setSelectedIndex(1);
        }
        
        jcb_integer.setSelectedItem(def_intfmt);
        s_item = jcb_integer.getSelectedItem();
        if (s_item != null  && s_item.toString().compareTo(def_intfmt) == 0)
            ;
        else  {
            jcb_integer.insertItemAt(def_intfmt, 2);
            jcb_integer.setSelectedIndex(1);
        }
        
        jcb_decimal.setSelectedItem(def_fltfmt);
        s_item = jcb_decimal.getSelectedItem();
        if (s_item != null  && s_item.toString().compareTo(def_fltfmt) == 0)
            ;
        else  {
            jcb_decimal.insertItemAt(def_fltfmt, 2);
            jcb_decimal.setSelectedIndex(1);
        }
        
//        jcb_integer.insertItemAt( def_intfmt, 1);
//        jcb_integer.setSelectedIndex(1);
//        
//        jcb_decimal.insertItemAt( def_fltfmt, 1);
//        jcb_decimal.setSelectedIndex(1);   
         setLocationRelativeTo(parent);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jl_Dates = new javax.swing.JLabel();
        jl_Integer = new javax.swing.JLabel();
        jl_decimal = new javax.swing.JLabel();
        jcb_date = new javax.swing.JComboBox();
        jcb_integer = new javax.swing.JComboBox();
        jcb_decimal = new javax.swing.JComboBox();
        OK = new javax.swing.JButton();
        Cancel = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jTabbedPane1.setName("Options");
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jl_Dates.setText("Date Format");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel1.add(jl_Dates, gridBagConstraints);

        jl_Integer.setText("Integer Format");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel1.add(jl_Integer, gridBagConstraints);

        jl_decimal.setText("Decimal");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanel1.add(jl_decimal, gridBagConstraints);

        jcb_date.setEditable(true);
        jcb_date.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Default", "MM/dd/yyyy", "yyyy/MM/dd", "dd/MM/yyyy", "yyyy.MM.dd G 'at' HH:mm:ss z", "EEE, MMM d, ''yy", "MMM dd, yyyy" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jcb_date, gridBagConstraints);

        jcb_integer.setEditable(true);
        jcb_integer.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Default", "###", "#,###" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jcb_integer, gridBagConstraints);

        jcb_decimal.setEditable(true);
        jcb_decimal.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Default", "##0.##E0", "0.###E0", "#,##0.0#;(#)", "#,##0.00#;(#)" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jcb_decimal, gridBagConstraints);

        jTabbedPane1.addTab("Formats", jPanel1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 5;
        getContentPane().add(jTabbedPane1, gridBagConstraints);

        OK.setText("OK");
        OK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OKActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(OK, gridBagConstraints);

        Cancel.setText("Cancel");
        Cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CancelActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(Cancel, gridBagConstraints);

        pack();
    }//GEN-END:initComponents

    private void CancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_CancelActionPerformed

    private void OKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OKActionPerformed
        
        // TODO add your handling code here:
        String fmt;
        
        fmt = jcb_date.getSelectedItem().toString();
        if (fmt.compareTo("Default") == 0)
            DwbjProps.setProperty("DateFormat", "");
        else
            DwbjProps.setProperty("DateFormat", fmt);
        
        fmt = jcb_integer.getSelectedItem().toString();
        if (fmt.compareTo("Default") == 0)
            DwbjProps.setProperty("IntegerFormat", "###");
        else
            DwbjProps.setProperty("IntegerFormat", fmt);
            
        //DwbjProps.setProperty("IntegerFormat", jcb_integer.getSelectedItem().toString());
        fmt = jcb_decimal.getSelectedItem().toString();
        if (fmt.compareTo("Default") == 0)
            DwbjProps.setProperty("DecimalFormat", "##.##");
        else
            DwbjProps.setProperty("DecimalFormat", fmt);
        
        //DwbjProps.setProperty("DecimalFormat", jcb_decimal.getSelectedItem().toString());
        
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_OKActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new OptionsDialog(new javax.swing.JFrame(), true).show();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Cancel;
    private javax.swing.JButton OK;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JComboBox jcb_date;
    private javax.swing.JComboBox jcb_decimal;
    private javax.swing.JComboBox jcb_integer;
    private javax.swing.JLabel jl_Dates;
    private javax.swing.JLabel jl_Integer;
    private javax.swing.JLabel jl_decimal;
    // End of variables declaration//GEN-END:variables
    
}
