package net.sourceforge.asse;

import java.io.*;
import java.net.*;


class readTextFromJar {

    public readTextFromJar () {

    }

    public static String get_resource(Class baseclass, 
				      String resource_name) {
	
	try {
	    ClassLoader cl = baseclass.getClassLoader();
	    URL url;
	    InputStream istream;

	    if ( (url = cl.getResource(resource_name)) == null ||
		 (istream = url.openStream()) == null )
		return "";
	    
	    BufferedInputStream br =  
		new BufferedInputStream(istream);
	    
	    StringWriter swriter = new StringWriter();
	    int singlechar;
	    while ((singlechar = br.read()) >= 0) {
		swriter.write(singlechar);
	    }
	    br.close();
	    istream.close();

	    return new String(swriter.getBuffer());

	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}
	return "";
    }

    public static void main(String arg[]) {

	readTextFromJar x = new readTextFromJar();
	try {
	    for (int i = 0; i < arg.length; i++) 
		System.out.print(readTextFromJar.get_resource(x.getClass(), arg[i]));
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
	
}
