package net.sourceforge.asse;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

class JButtonPanel extends JPanel {

    JButton[] jba = new JButton[0];


    public JButtonPanel ( String bnames[] ) {

	super(new FlowLayout(FlowLayout.LEFT, 1, 0));
	add_buttons(bnames);
    }
    
    public void add_buttons(String bnames[]) {

	JButton[] jba1 = new JButton[ jba.length + bnames.length ];
	
	for (int i=0; i < jba.length; i++ ) {
	    jba1[i] = jba[i];
	}

	JButton x;
	for (int i=0; i < bnames.length; i++ ) {
	    x = new JButton( bnames[i]);
	    jba1[jba.length + i] = x;
	    this.add(x);
	}
	
	jba = jba1;

    }

    public void setEnabled(String blabel, boolean enabled) {
	for(int i=0; i < jba.length; i++) {
	    if (blabel.compareTo(jba[i].getText()) == 0) {
		jba[i].setEnabled(enabled);
	    }
	}
    }
	
    public void addActionListener(ActionListener al ) {
	for(int i=0; i < jba.length; i++) {
	    jba[i].addActionListener(al);
	}
    }
		
    public void removeActionListener(ActionListener al) {
	for(int i=0; i < jba.length; i++) {
	    try {
		jba[i].addActionListener(al);
	    } 
	    catch (Exception ex) {
	    }
	}
    }	
    public void addActionListener( String blabel, ActionListener al ) {
		
	for(int i=0; i < jba.length; i++) {
	    if (blabel.compareTo(jba[i].getText()) == 0) {
		jba[i].addActionListener(al);
		//System.out.println(jba[i].getText());
		return;
	    }
	}
	System.out.println("None of the buttons matched !");

    }
}
		
		
