package net.sourceforge.asse;

import java.awt.event.*;
import javax.swing.*;
import java.util.*;


class JMenuBarEx extends JMenuBar {

    public JMenuBarEx() {
        super();
    }
    
    public void addActionListener(ActionListener al) {
        add_them_all( al, this );
    }
    
    public boolean setEnabled(String str, boolean shouldEnable) {
        JMenuItem x = locateString(this, str);
        if (x != null) {
            x.setEnabled(shouldEnable);
            return true;
        }
        return false;
    }
    
    public void setItems(Hashtable toSet) {
        setItems(this, toSet);
    }
    
    private void setItems(MenuElement x, Hashtable toSet) {
        
        MenuElement me[] = x.getSubElements();
        for (int i = 0; i < me.length; i++) {
            JMenuItem jme;
            if (me[i] instanceof JMenuItem) {
                jme = (JMenuItem) me[i];
                Object o1 = toSet.get(jme.getText());
                if (o1 != null && o1 instanceof Boolean) {
                    Boolean b1 = (Boolean)o1;
                    jme.setEnabled(b1.booleanValue());
                }
            }
            setItems(me[i],toSet);
        }
        return;
    }
    //
    //    // Locates the JMenuItem with the given string.
    //    public JMenuItem locateString(String label) {
    //	MenuElement me[] = getSubElements();
    //	for (int i = 0; i < me.length; i++) {
    //	    JMenuItem jme;
    //	    if (me[i] instanceof JMenuItem) {
    //		jme = (JMenuItem) me[i];
    //		if (label.compareTo(jme.getText())==0)
    //		    return (jme);
    //	    }
    //	    jme = locateString(me[i], label);
    //	    if (jme != null)
    //		return jme;
    //	}
    //	return null;
    //    }
    
    private JMenuItem locateString(MenuElement jmp, String label) {
        MenuElement me[] = jmp.getSubElements();
        JMenuItem jme;
        for (int i = 0; i < me.length; i++) {
            if (me[i] instanceof JMenuItem) {
                jme = (JMenuItem) me[i];
                if (label.compareTo(jme.getText())==0)
                    return (jme);
            }
            jme = locateString(me[i], label);
            if (jme != null)
                return jme;
        }
        return null;
    }
    
    private void add_them_all( ActionListener al, MenuElement item) {
        JMenuItem     jmi;
        MenuElement   jme[] = item.getSubElements();
        
        for (int i = jme.length - 1; i >= 0; i-- ) {
            if ( jme[i] instanceof JMenuItem) {
                if (!(jme[i] instanceof JMenu)) {
                    jmi = (JMenuItem) jme[i];
                    jmi.addActionListener(al);
                } else {
                    add_them_all( al, jme[i] ) ;
                }
            } else
                add_them_all( al, jme[i] ) ;
        }
    }
    
    
}



