package net.sourceforge.asse;

import javax.swing.table.*;
import java.io.*;

class PrintTableModel {
    
    
    public static void print(TableModel table, PrintStream prn) {

	try {
	    int rows= table.getRowCount();
	    int cols  = table.getColumnCount();
	    for (int i = 0; i < cols; i++) 
		prn.print( table.getColumnName(i) + "\t");
	    prn.print("\n");

	    for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
		    Object o;
		    o = table.getValueAt(i,j);
		    if (o != null) 
			prn.print(o.toString() + "\t");
		    else 
			prn.print("NULL\t");
		}
		prn.print("\n");
	    } 
	    prn.print("\n");
	} 
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }

}

