
package net.sourceforge.asse;
import java.awt.event.*;


class ReportFrame extends asseInternalFrame
    implements ActionListener {

    public ReportFrame(String title, AReport[] rpts) {
        
        setMenuItem("Close Window",  Boolean.TRUE);
        setMenuItem("Print Table", Boolean.TRUE);
        setMenuItem("Save Table As...", Boolean.TRUE);
        setMenuItem("Show as Plain Text", Boolean.TRUE);
        setMenuItem("CopyKeys", Boolean.TRUE);
//        setMenuItem("PasteKeys", Boolean.TRUE);
//        setMenuItem("Stop", Boolean.TRUE);
        setMenuItem("Run", Boolean.TRUE);
   	initComponents(title, rpts);
    }

    private void initComponents(String title, AReport[] rpts) {
	setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setClosable(true);
        setTitle(title);

	reportp = new ReportPanel(this, rpts);
	//getContentPane().add(reportp, java.awt.BorderLayout.CENTER);
	getContentPane().add(reportp);
        pack();
    }

    public void actionPerformed(ActionEvent e) {
        reportp.actionPerformed(e);
    }
    
//    JMenuBarEx menuBar;
    AReport rpt;
    ReportPanel reportp;
    public java.util.Hashtable menuStatus = new java.util.Hashtable();
}
