package net.sourceforge.asse;

import java.awt.event.*;
import javax.swing.*;
import java.util.*;


class ReportMenu extends JMenuBarEx {

	
    public ReportMenu () {
	
	
	JMenu jm = new JMenu("File");
	JMenuItem jmi;

	jm.setMnemonic(KeyEvent.VK_F);
	jm.add(jmi = new JMenuItem("Print Report"));
	jmi.setToolTipText("Print Report");
	jm.add(jmi = new JMenuItem("Save Report As ..", KeyEvent.VK_T));
	jmi.setToolTipText("Save result to a tab-delimited file.");
	this.add(jm);

	jm = new JMenu("Edit");
	jm.setMnemonic(KeyEvent.VK_E);
	jm.add(jmi = new JMenuItemEx("Copy", KeyEvent.VK_C, KeyEvent.VK_C));
	jm.add(jmi = new JMenuItemEx("CopyTable", KeyEvent.VK_8, KeyEvent.VK_8));
	jm.add(jmi = new JMenuItemEx("Cut", KeyEvent.VK_T, KeyEvent.VK_T));
	jm.add(jmi = new JMenuItemEx("Paste", KeyEvent.VK_P, KeyEvent.VK_V));
	this.add(jm);

	jm = new JMenu("Query");
	jm.setMnemonic(KeyEvent.VK_Q);
	jm.add(jmi = new JMenuItemEx("Retrieve", KeyEvent.VK_R, KeyEvent.VK_R));
	jmi.setToolTipText("Execute SQL and Retrieve results");
//  	jm.add(jmi = new JMenuItemEx("Insert", KeyEvent.VK_I,KeyEvent.VK_I));
//  	jmi.setToolTipText("Insert a new row into local buffer");
//  	jm.add(jmi = new JMenuItemEx("Delete", KeyEvent.VK_D,KeyEvent.VK_D));
//  	jmi.setToolTipText("Delete selected rows from the local buffer");
//  	jm.add(jmi = new JMenuItem("Show Deleted"));
//  	jmi.setToolTipText("Show locally deleted rows, works before commit");
//  	jm.add(jmi = new JMenuItemEx("Commit", KeyEvent.VK_O, KeyEvent.VK_O));
//  	jmi.setToolTipText("Commit local buffer changes  to the database.");
//  	jm.add(jmi = new JMenuItem("Duplicate Rows"));
//  	jmi.setToolTipText("Duplicate selected rows to reInsert.");
//  	jm.add(jmi = new JMenuItem("Reset"));
//  	jmi.setToolTipText("Reset a modified row to original values");
//  	jm.add(jmi = new JMenuItem("Clear Results"));
//  	jmi.setToolTipText("Clear local buffer, and ends confusion !");
  	this.add(jm);

	jm = new JMenu("Help");
	jm.setMnemonic(KeyEvent.VK_H);
	jm.add(jmi = new JMenuItem("No_Help_Yet"));
	jmi.setToolTipText("Please see the manual.");
	jm.add(jmi = new JMenuItem("About", KeyEvent.VK_A));
	jmi.setToolTipText("Let me brag..");

	this.add(jm);
    }
	
}


