/*
 * asseInternalFrame.java
 *
 * Created on November 3, 2004, 12:21 PM
 */

package net.sourceforge.asse;
import javax.swing.event.*;
import javax.swing.*;

/**
 *
 * @author  manshah
 */
public class asseInternalFrame extends javax.swing.JInternalFrame {
    
    /** Creates a new instance of asseInternalFrame */
    public asseInternalFrame() {
        
        menudefs.put("Close Window",  Boolean.FALSE);
        menudefs.put("Print Table", Boolean.FALSE);
        menudefs.put("Save Table As...", Boolean.FALSE);
        menudefs.put("Print Report", Boolean.FALSE);
        menudefs.put("Save Report As...", Boolean.FALSE);
        menudefs.put("File Save", Boolean.FALSE);
        menudefs.put("File Save As...", Boolean.FALSE);
        menudefs.put("Insert Query From...", Boolean.FALSE);
        
        menudefs.put("Show as Plain Text", Boolean.FALSE);
        
        menudefs.put("Print SQL", Boolean.FALSE);
        //The following is always on.
        //menudefs.put("Read Servers From...", Boolean.FALSE);
        menudefs.put("PasteKeys", Boolean.FALSE);
        menudefs.put("Undo", Boolean.FALSE);
        menudefs.put("Redo", Boolean.FALSE);
        menudefs.put("Find", Boolean.FALSE);
        menudefs.put("Stop", Boolean.FALSE);
        menudefs.put("Run", Boolean.FALSE);
        menudefs.put("Insert", Boolean.FALSE);
        menudefs.put("Delete", Boolean.FALSE);
        menudefs.put("Show Deleted", Boolean.FALSE);
        menudefs.put("Commit", Boolean.FALSE);
        menudefs.put("Duplicate Rows", Boolean.FALSE);
        menudefs.put("Reset", Boolean.FALSE);
        menudefs.put("Clear Results", Boolean.FALSE);
        
        addInternalFrameListener( new InternalFrameAdapter() {
            public void internalFrameActivated(InternalFrameEvent e) {
                refreshMenu();
            }
            public void internalFrameClosing(InternalFrameEvent e) {
                menuoverrides.clear();
                refreshMenu();
            }
            
        } );
          
       
    }
    
    public void setMenuItem(String key, Boolean value) {
        menuoverrides.put(key, value);
    }
    
    public void refreshMenu() {
        JMenuBar jmb = assemdi_frame.get().getJMenuBar();
        if (jmb instanceof JMenuBarEx) {
              JMenuBarEx x = (JMenuBarEx)jmb;
              x.setItems(menudefs);
              x.setItems(menuoverrides);
        }
    }
    
    java.util.Hashtable menudefs = new java.util.Hashtable();
    java.util.Hashtable menuoverrides = new java.util.Hashtable();
}
