
package net.sourceforge.asse;

import javax.swing.undo.*;


class asseUndo extends UndoManager {

    asseInternalFrame iframe;

    public asseUndo (asseInternalFrame ifr) {
	super();
	iframe = ifr;
	this.setLimit(15);
    }
	
    public boolean addEdit(UndoableEdit anEdit) {
	boolean ret = super.addEdit(anEdit);
	iframe.setMenuItem("Undo",this.canUndo() ? Boolean.TRUE : Boolean.FALSE);
        iframe.setMenuItem("Redo",this.canRedo() ? Boolean.TRUE : Boolean.FALSE);
        iframe.refreshMenu();
	return ret;
    }

    public void undo() {
	super.undo();
	iframe.setMenuItem("Undo",this.canUndo() ? Boolean.TRUE : Boolean.FALSE);
        iframe.setMenuItem("Redo",this.canRedo() ? Boolean.TRUE : Boolean.FALSE);
	iframe.refreshMenu();
    }
    public void redo() {
	super.redo();
	iframe.setMenuItem("Undo",this.canUndo() ? Boolean.TRUE : Boolean.FALSE);
        iframe.setMenuItem("Redo",this.canRedo() ? Boolean.TRUE : Boolean.FALSE);
	iframe.refreshMenu();
    }

}
	

    
