
package net.sourceforge.asse;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class myframe extends JFrame {
    
    String key;
    int   startheight;
    int   startwidth;

   public myframe(String title) {
      super(title); 
      key = title;
      new DwbjProps(); 
      
      startwidth  = DwbjProps.getIntProperty(key + "width", 0);
      startheight = DwbjProps.getIntProperty(key + "height", 0);

      this.addComponentListener(
      	new ComponentAdapter() {
      		public void componentResized(ComponentEvent e) {
		    DwbjProps.setIntProperty(key + "height", getHeight());
		    DwbjProps.setIntProperty(key + "width", getWidth());
		}
      	}
      );

   }

    public void initMySize() {
	
	Dimension x = Toolkit.getDefaultToolkit().getScreenSize();
    	initMySize( (int) (x.getWidth() * .80),(int) (x.getHeight() * .80));
	
    }
	

    public void initMySize(int swidth, int sheight) {
	if (0 == startwidth) 
	    startwidth = swidth;
	if (0 == startheight) 
	    startheight = sheight;

	setSize(startwidth,startheight);
    }

    public void locateToCenter() {
	
	Dimension x = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation( (int)((x.getWidth() - startwidth)/2),
		     (int)((x.getHeight() - startheight)/2) );

    }
}

